# OpenXR Facial Tracking Unreal Feature

To help software developers create an application with actual facial expressions on 3D avatars with the OpenXR facial tracing extension [XR_HTC_facial_tracking](https://www.khronos.org/registry/OpenXR/specs/1.0/html/xrspec.html).

## Enable Plugins
1. **Edit** > **Plugins** > Search for **OpenXR** and **ViveOpenXR**. Verify that those plugins has been enabled.
2. Note that the **"Steam VR"** plugin must be disabled for OpenXR to work.
3. You need to restart the engine for changes to take effect.

## Play the sample map  
1. Please make sure the **OpenXR Facial Tracking extension** is enabled, the setting is in **Edit** > **Project Settings** > **Plugins** > **Vive OpenXR**.
2. The sample map is under **Content** > **Map** > **FacialTrackingMap**.
3. The actor **SRanipal_AvatarSample** has settings for **Enable/ Disable Eye and Lip**, which you can find in the **Details** window.
4. Refer to **SRanipal_AvatarSample.cpp** for getting Eye/Lip facial expressions part.

## How to use OpenXR Facial Tracking Unreal Feature
1. Please make sure **ViveOpenXR** Plugin is in your project's **Plugins** folder, if not, Copy it to your game's Plugins directory. Skip this step if using the example **ViveOpenXRPlugins** project.
2. **Edit** > **Project Settings** > **Plugins** > **Vive OpenXR** > Click **Enable Facial Tracking** under **Facial Tracking** to enable OpenXR Facial Tracking extension.
3. You need to restart the engine to apply new settings after clicking **Enable Facial Tracking**.
4. For the available FacialTracking functions, please refer to [ViveOpenXR.h](../../Source/ViveOpenXR/Public/ViveOpenXR.h).