# OpenXR FacialTracking + MetaHuman Unreal Feature

To help software developers create an application with actual facial expressions on 3D avatars with the OpenXR facial tracing extension [XR_HTC_facial_tracking](https://www.khronos.org/registry/OpenXR/specs/1.0/html/xrspec.html).

## Enable Plugins
1. **Edit** > **Plugins** > Search for **OpenXR** and **ViveOpenXR**. Verify that those plugins has been enabled.
2. Note that the **"Steam VR"** plugin must be disabled for OpenXR to work.
3. You need to restart the engine for changes to take effect.

## Play the sample map  
1. Please make sure the **OpenXR Facial Tracking extension** is enabled, the setting is in **Edit** > **Project Settings** > **Plugins** > **Vive OpenXR**.
2. The sample map is under **Content** > **Map** > **MetaHumanMap**.
3. The actor **BP_XR_FT_Manager** has settings for **Enable/ Disable Eye and Lip**, which you can find in the **Details** window.
4. Refer to **ViveOpenXR Content** > **MetaHumanAssets** > **Animation** > **XR_Face_AnimBP** for getting Eye/Lip facial expressions part.

## How to use OpenXR Facial Tracking + MetaHuman Unreal Feature
1. Please make sure **ViveOpenXR** Plugin is in your project's **Plugins** folder, if not, Copy it to your game's Plugins directory. Skip this step if using the example **ViveOpenXRPlugins** project.
2. **Edit** > **Project Settings** > **Plugins** > **Vive OpenXR** > Click **Enable Facial Tracking** under **Facial Tracking** to enable OpenXR Facial Tracking extension.
3. You need to restart the engine to apply new settings after clicking **Enable Facial Tracking**.
4. For the available FacialTracking functions, please refer to [ViveOpenXR.h](../../Source/ViveOpenXR/Public/ViveOpenXR.h).
5. Import **Your MetaHuman** in your project.
6. After **step 5**, you need to do **Retarget Skeleton** for the **three Anim Assets** under **ViveOpenXR Content** > **MetaHumanAssets** > **Animation** :
    * **mh_XR_FacialTracking_mapping_anim**
    * **mh_XR_FacialTracking_mapping_pose**
    * **XR_Face_AnimBP**
* How to **Retarget Skeleton** :
    > 1. Double click those `three Anim Assets`.
    > 2. Click the `Yes` button on the **Message** window.
    > 3. In the **Select Skeleton** window, you need to choose `Face_Archetype_Skeleton` _(This skeleton is MetaHuman's Face skeleton)_ and click `Retarget` button.

 7. Drag the actor **ViveOpenXR Content** > **MetaHumanAssets** > **Blueprint** > **BP_XR_FT_Manager** to **your_level**, you can find settings for **Enable/ Disable Eye and Lip** in the **Details** window.
 8. Set **XR_Face_AnimBP** to your MetaHuman :
    * Open your MetaHuman Blueprint.
    * Choose the **Face(or Head) skeleton component**.
    * Go to the **Details** window and set **XR_Face_AnimBP** in the **Animation > Anim Class**.