# OpenXR SceneUnderstanding Unreal Feature

Demonstrate configuring, calculating and generating mesh of surrouding environments by the OpenXR scene understanding extension [XR_MSFT_scene_understanding](https://www.khronos.org/registry/OpenXR/specs/1.0/html/xrspec.html#XR_MSFT_scene_understanding).

## Enable Plugins
1. **Edit** > **Plugins** > Search for **OpenXR** and **ViveOpenXR**. Verify that those plugins has been enabled.
2. Note that the **"Steam VR"** plugin must be disabled for OpenXR to work.
3. You need to restart the engine for changes to take effect.

## Play the sample map
1. Please make sure the **OpenXR Scene Understanding extension** is enabled, the setting is in **Edit** > **Project Settings** > **Plugins** > **Vive OpenXR**.
2. The sample map is under **Content** > **Map** > **SceneUnderstandingMap**.
3. Refer to the actor **BP_SceneUnderstanding** for getting generated mesh(Tracked Geometry) part.

## How to use OpenXR SceneUnderstanding Unreal Feature
1. Please make sure **ViveOpenXR** Plugin is in your project's **Plugins** folder, if not, Copy it to your game's Plugins directory. Skip this step if using the example **ViveOpenXRPlugins** project.
2. **Edit** > **Project Settings** > **Plugins** > **Vive OpenXR** > Click **Enable Scene Understanding** under **Scene Understanding** to enable OpenXR Scene Understanding extension.
3. You need to restart the engine to apply new settings after clicking **Enable Scene Understanding**.
4. For the available SceneUnderstanding functions, please refer to [ViveOpenXR.h](../../Source/ViveOpenXR/Public/ViveOpenXR.h).
5. The SceneUnderstanding plugin uses the ue4 feature [OpenXRARTrackedGeometryHolder](https://docs.unrealengine.com/4.27/en-US/API/Plugins/OpenXRHMD/IOpenXRARModule/GetTrackedMeshHolder/) to update and draw mesh (geometry), refer to [SceneUnderstanding.cpp](../../Source/ViveOpenXR/Private/SceneUnderstanding.cpp).


## Sample map's controller control
1. `Grip`: Shoot balls to overlap OpenXR scene understanding snapshot mesh.
2. `Trigger`: Shoot laser to hit OpenXR scene understanding snapshot mesh.
3. `Cosmos Button A` or `Cosmos Button X` or `Vive pro Trackpad`: Switch OpenXR scene understanding snapshot mesh's occlusion/default material.