// Copyright (c) 2022 HTC Corporation. All Rights Reserved.

#include "AnimGraphNode_FacialTrackingPose.h"

#include "EdGraph/EdGraphSchema.h"

#define LOCTEXT_NAMESPACE "ViveOpenXRFacialTrackingAnimNode"

FText UAnimGraphNode_FacialTrackingPose::GetNodeTitle(ENodeTitleType::Type TitleType) const
{
	return LOCTEXT("NodeTitle", "Facial Tracking Pose");
}

FText UAnimGraphNode_FacialTrackingPose::GetTooltipText() const
{
	return LOCTEXT("NodeTooltip", "Retrieves the current pose associated with the supplied subject");
}

FText UAnimGraphNode_FacialTrackingPose::GetMenuCategory() const
{
	return LOCTEXT("NodeCategory", "ViveOpenXR Facial Tracking");
}

/*
void UAnimGraphNode_FacialTrackingPose::ConvertDeprecatedNode(UEdGraph* Graph, bool bOnlySafeChanges)
{
	//Find deprecated SubjectName pin and set new pin with its value
	const FName OldPinName = TEXT("SubjectName"); //Variable now has _DEPRECATED appended so can't use GET_MEMBER_NAME_CHECKED
	const FName NewPinName = GET_MEMBER_NAME_CHECKED(FAnimNode_LiveLinkPose, LiveLinkSubjectName);
	UEdGraphPin** FoundPinPtr = Pins.FindByPredicate([OldPinName](const UEdGraphPin* Other) { return Other->PinName == OldPinName; });
	if (FoundPinPtr != nullptr)
	{
		UEdGraphPin** FoundNewPinPtr = Pins.FindByPredicate([NewPinName](const UEdGraphPin* Other) { return Other->PinName == NewPinName; });
		if (FoundNewPinPtr != nullptr)
		{
			UScriptStruct* StructType = FLiveLinkSubjectName::StaticStruct();
			UEdGraphPin* OldPin = *FoundPinPtr;
			UEdGraphPin* NewPin = *FoundNewPinPtr;

			//Create new structure from old data
			FLiveLinkSubjectName NewName;
			NewName.Name = *OldPin->DefaultValue;

			//Apply new name structure 
			FString StringValue;
			StructType->ExportText(StringValue, &NewName, nullptr, nullptr, EPropertyPortFlags::PPF_None, nullptr);
			NewPin->GetSchema()->TrySetDefaultValue(*NewPin, StringValue);

			//Update node data with graph data
			Node.LiveLinkSubjectName = NewName;
		}
	}
}
*/
#undef LOCTEXT_NAMESPACE